package _VisualDVM.GlobalData.Machine;
import Common.Visual.UI_;
import _VisualDVM.Current;
import Common.Visual.DataSetControlForm;
import _VisualDVM.Visual.UI;
import Common.Visual.Windows.Dialog.DBObjectDialog;
import Common.Database.Objects.DBObject;
import Common.Database.Tables.FKBehaviour;
import Common.Database.Tables.FKCurrentObjectBehaviuor;
import Common.Database.Tables.FKDataBehaviour;
import Common.Database.Tables.iDBTable;
import _VisualDVM.GlobalData.Compiler.Compiler;
import _VisualDVM.GlobalData.DVMParameter.DVMParameter;
import _VisualDVM.GlobalData.EnvironmentValue.EnvironmentValue;
import _VisualDVM.GlobalData.Machine.UI.MachineFields;
import _VisualDVM.GlobalData.Makefile.Makefile;
import _VisualDVM.GlobalData.Module.Module;
import _VisualDVM.GlobalData.RunConfiguration.RunConfiguration;
import _VisualDVM.GlobalData.Tasks.CompilationTask.CompilationTask;
import _VisualDVM.GlobalData.Tasks.RunTask.RunTask;
import _VisualDVM.GlobalData.User.User;

import java.util.LinkedHashMap;
public class MachinesDBTable extends iDBTable<Machine> {
    public MachinesDBTable() {
        super(Machine.class);
    }
    @Override
    public String getSingleDescription() {
        return "машина";
    }
    @Override
    public String getPluralDescription() {
        return "машины";
    }
    @Override
    public DBObjectDialog<Machine, MachineFields> getDialog() {
        return new DBObjectDialog<Machine, MachineFields>(MachineFields.class) {
            @Override
            public int getDefaultHeight() {
                return 250;
            }
            @Override
            public void validateFields() {
                if (fields.tfAddress.getText().isEmpty())
                    Log.Writeln("Адрес машины не может быть пустым");
            }
            @Override
            public void fillFields() {
                fields.tfName.setText(Result.name);
                fields.tfAddress.setText(Result.address);
                fields.sPort.setValue(Result.port);
                UI_.TrySelect(fields.cbMachineType, Result.type);
            }
            @Override
            public void ProcessResult() {
                Result.name = fields.tfName.getText();
                Result.address = fields.tfAddress.getText();
                Result.port = (int) fields.sPort.getValue();
                Result.type = (MachineType) fields.cbMachineType.getSelectedItem();
            }
            @Override
            public void SetEditLimits() {
                fields.cbMachineType.setEnabled(false);
            }

        };
    }
    @Override
    public LinkedHashMap<Class<? extends DBObject>, FKBehaviour> getFKDependencies() {
        LinkedHashMap<Class<? extends DBObject>, FKBehaviour> res = new LinkedHashMap<>();
        //-
        res.put(User.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.ACTIVE));
        res.put(Compiler.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.ACTIVE));
        res.put(Makefile.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.ACTIVE));
        res.put(RunConfiguration.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.ACTIVE));
        //-
        res.put(Module.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.PASSIVE));
        res.put(EnvironmentValue.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.PASSIVE));
        res.put(DVMParameter.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.PASSIVE));
        res.put(CompilationTask.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.ACTIVE));
        res.put(RunTask.class, new FKBehaviour(FKDataBehaviour.DELETE, FKCurrentObjectBehaviuor.PASSIVE));
        return res;
    }
    @Override
    protected DataSetControlForm createUI() {
        return new DataSetControlForm(this) {
            @Override
            public void ShowCurrentObject() throws Exception {
                super.ShowCurrentObject();
                UI.getMainWindow().getTestingWindow().ShowCurrentCompiler();
                UI.credentialsBar.ShowMachine();
            }
            @Override
            public void ShowNoCurrentObject() throws Exception {
                super.ShowNoCurrentObject();
                UI.getMainWindow().getTestingWindow().ShowCurrentCompiler();
                UI.credentialsBar.ShowNoMachine();
            }
            @Override
            protected void AdditionalInitColumns() {
                columns.get(0).setVisible(false);
            }
        };
    }
    @Override
    public String[] getUIColumnNames() {
        return new String[]{"URL"};
    }
    @Override
    public Object getFieldAt(Machine object, int columnIndex) {
        switch (columnIndex) {
            case 1:
                return object.getURL();
            default:
                return null;
        }
    }
    @Override
    public Current CurrentName() {
        return Current.Machine;
    }
    public boolean LocalMachineExists() {
        return Data.values().stream().anyMatch(machine -> machine.type.equals(MachineType.Local));
    }
}
